/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 02/11/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.RuanganDto;
import com.portofolio.service.RuanganService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;

@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/ruangan")
public class RuanganController extends LocaleController {
	@Lazy
	@Autowired
	private RuanganService ruanganService;
	
	@ApiOperation("Api Untuk MenyimpanRuangan")
	@PostMapping("/save")
	public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody RuanganDto dto, HttpServletRequest request) {
		Map<String, Object> result = ruanganService.save(dto);
		return RestUtil.getJsonResponse(result);
	}
	
	@ApiOperation("Api Untuk Menampilkan SemuaRuangan")
	@GetMapping("/grid")
	public ResponseEntity<Map<String, Object>> find(
			@RequestParam(value = "dir", defaultValue = "namaRuangan") String dir,
			@RequestParam(value = "sort", defaultValue = "desc") String sort,
			@RequestParam(value = "namaRuangan", required = false, defaultValue = "") String namaRuangan,
			@RequestParam(value = "statusEnabled", required = true) boolean statusEnabled) {
		Map<String, Object> result = ruanganService.grid(sort, dir, namaRuangan,statusEnabled);
		
		return RestUtil.getJsonResponse(result);
	}
	
	@ApiOperation("Api Menampilkan Ruangan")
	@GetMapping("/findByKdRuangan")
	public ResponseEntity<Map<String, Object>> findByKdRuangan(
			@RequestParam(value = "kdRuangan", required = true)String kdRuangan,
			@RequestParam(value = "isHierarki", required = true) boolean isHierarki
			) {
		Map<String, Object> result = ruanganService.findByKdRuangan(kdRuangan, isHierarki);
		return RestUtil.getJsonResponse(result);
	}
	
	@ApiOperation("Api Untuk Update Ruangan")
	@PutMapping("/update")
	public ResponseEntity<Map<String, Object>> update(
			@RequestParam(value = "kdRuangan", required = true) String kdRuangan,
			@RequestParam(value = "version", required = true) Integer version, 
			@Valid @RequestBody RuanganDto entity,
			HttpServletRequest request) {
		Map<String, Object> result = ruanganService.update(entity,kdRuangan,version);
		
		return RestUtil.getJsonResponse(result);
	}
	
	
	
	@ApiOperation("Api Untuk Update Ruangan")
	@DeleteMapping("/delete")
	public ResponseEntity<Map<String, Object>> delete(
			@RequestParam(value = "kdRuangan", required = true) String kdRuangan,
			@RequestParam(value = "version", required = true) Integer version,
			HttpServletRequest request) {
		Map<String, Object> result = ruanganService.deleteByKdRuangan(kdRuangan, version);
		
		return RestUtil.getJsonResponse(result);
	}
	
	
	
	

}
